///////////////////////////////////////////////////////////////////////////////
// IUT de Provence, site d'Arles                                      
// Dpartement Informatique
// ----------------------------------------------------------------------------
// IN - Synthse d'images - Modlisation gomtrique
// Auteur : Gilles Gesquire
// ----------------------------------------------------------------------------
// Base du TP 1
// programme permettant de crer des formes de bases.
// La forme reprsente ici est un polygone blanc dessin sur un fond rouge
///////////////////////////////////////////////////////////////////////////////  

#include <stdio.h>      
#include <stdlib.h>     
#include <math.h>


/* Dans les salles de TP, vous avez gnralement accs aux glut dans C:\Dev. Si ce n'est pas le cas, tlchargez 
l'archive glut.zip  sur mon site).
Vous pouvez ensuite y faire rfrence en spcifiant le chemin dans visual. Vous utiliserez alors #include <glut.h>. 
Si vous mettez glut dans le rpertoire courant, on aura alors #include "glut.h" 
*/

#include <glut.h> 

// Dfinition de la taille de la fentre
#define WIDTH  480
#define HEIGHT 480

// Dfinition de la couleur de la fentre
#define RED   1
#define GREEN 0
#define BLUE  0
#define ALPHA 1


// Touche echap (Esc) permet de sortir du programme
#define KEY_ESC 27


// Enttes de fonctions
void init_scene();
void render_scene();
GLvoid initGL();
GLvoid window_display();
GLvoid window_reshape(GLsizei width, GLsizei height); 
GLvoid window_key(unsigned char key, int x, int y); 


int main(int argc, char **argv) 
{  
  // initialisation  des paramtres de GLUT en fonction
  // des arguments sur la ligne de commande
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA);

  // dfinition et cration de la fentre graphique, ainsi que son titre
  glutInitWindowSize(WIDTH, HEIGHT);
  glutInitWindowPosition(0, 0);
  glutCreateWindow("Premier exemple : carr");

  // initialisation de OpenGL et de la scne
  initGL();  
  init_scene();

  // choix des procdures de callback pour 
  // le trac graphique
  glutDisplayFunc(&window_display);
  // le redimensionnement de la fentre
  glutReshapeFunc(&window_reshape);
  // la gestion des vnements clavier
  glutKeyboardFunc(&window_key);

  // la boucle prinicipale de gestion des vnements utilisateur
  glutMainLoop();  

  return 1;
}

// initialisation du fond de la fentre graphique : noir opaque
GLvoid initGL() 
{
  glClearColor(RED, GREEN, BLUE, ALPHA);        
}

// Initialisation de la scene. Peut servir  stocker des variables de votre programme
//  initialiser
void init_scene()
{
}

// fonction de call-back pour laffichage dans la fentre

GLvoid window_display()
{
  glClear(GL_COLOR_BUFFER_BIT);
  glLoadIdentity();

  // C'est l'endroit o l'on peut dessiner. On peut aussi faire appel
  //  une fonction (render_scene() ici) qui contient les informations 
  // que l'on veut dessiner
  render_scene();

  // trace la scne grapnique qui vient juste d'tre dfinie
  glFlush();
}

// fonction de call-back pour le redimensionnement de la fentre

GLvoid window_reshape(GLsizei width, GLsizei height)
{  
  glViewport(0, 0, width, height);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  // ici, vous verrez pendant le cours sur les projections qu'en modifiant les valeurs, il est
  // possible de changer la taille de l'objet dans la fentre. Augmentez ces valeurs si l'objet est 
  // de trop grosse taille par rapport  la fentre.
  glOrtho(-2.0, 2.0, -2.0, 2.0, -2.0, 2.0);

  // toutes les transformations suivantes sappliquent au modle de vue 
  glMatrixMode(GL_MODELVIEW);
}

// fonction de call-back pour la gestion des vnements clavier

GLvoid window_key(unsigned char key, int x, int y) 
{  
  switch (key) {    
  case KEY_ESC:  
    exit(1);                    
    break; 
    
  default:
    printf ("La touche %d nest pas active.\n", key);
    break;
  }     
}



//////////////////////////////////////////////////////////////////////////////////////////
// Fonction que vous allez modifier afin de dessiner
/////////////////////////////////////////////////////////////////////////////////////////
void render_scene()
{
  glColor3f(1.0, 1.0, 1.0);

  //  Nous crons ici un polygone. Nous pourrions aussi crer un triangle ou des lignes. Voir ci-dessous les parties 
  // en commentaires (il faut commenter le bloc qui ne vous intresse pas et dcommenter celui que vous voulez tester.

	glBegin(GL_POLYGON);
		glVertex3f(-1, -1, 0);
		glVertex3f(1, -1, 0);
		glVertex3f(1, 1, 0);
		glVertex3f(-1, 1, 0);
	glEnd();

/*
// cration d'un triangle
	glBegin(GL_TRIANGLES);
		glVertex3f(-1, -1, 0);
		glVertex3f(1, -1, 0);
		glVertex3f(1, 1, 0);
	glEnd();
*/



/* // Cration de deux lignes
	glBegin(GL_LINES);
		glVertex3f(-1, -1, 0);
		glVertex3f(1, 1, 0);
		glVertex3f(1, -1, 0);
		glVertex3f(-1, 1, 0); 
	glEnd();
*/


}
